"use strict";

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var _require = require('datocms-client'),
    SiteClient = _require.SiteClient,
    Loader = _require.Loader;

var CLIENT_HEADERS = {
  'X-Reason': 'dump',
  'X-SSG': 'gatsby'
};
var GATSBY_CLOUD = process.env.GATSBY_CLOUD;
var GATSBY_EXECUTING_COMMAND = process.env.gatsby_executing_command;
var loaders = {};

function getLoader(_ref) {
  var cache = _ref.cache,
      loadStateFromCache = _ref.loadStateFromCache,
      options = _objectWithoutProperties(_ref, ["cache", "loadStateFromCache"]);

  var apiToken = options.apiToken,
      apiUrl = options.apiUrl,
      environment = options.environment,
      logApiCalls = options.logApiCalls,
      pageSize = options.pageSize,
      rawPreviewMode = options.previewMode;
  var clientOptions = {
    headers: CLIENT_HEADERS
  };

  if (options.environment) {
    clientOptions.environment = environment;
  }

  if (options.baseUrl) {
    clientOptions.baseUrl = apiUrl;
  }

  if (options.logApiCalls) {
    clientOptions.logApiCalls = logApiCalls;
  }

  var loaderArgs = [[apiToken, clientOptions], GATSBY_CLOUD && GATSBY_EXECUTING_COMMAND === 'develop' || process.env.GATSBY_IS_PREVIEW === "true" || rawPreviewMode, environment, {
    pageSize: pageSize
  }];
  var key = JSON.stringify(loaderArgs);

  if (loaders[key]) {
    return loaders[key];
  }

  var loader = _construct(Loader, loaderArgs);

  if (loadStateFromCache) {
    loader.loadStateFromCache(cache);
  }

  loaders[key] = loader;
  return loader;
}

module.exports = {
  getLoader: getLoader
};